#include "tricks.h"

#include <conio.h>
#include <stdio.h>

struct facep
{
   float x,y,z;
   float px,py;
   
   byte col;
};

// ********

facep kubp[8];
facep rotp[8];
int   kubf[6][4];

int startx[200];
int endx[200];

byte startcol[200];
byte endcol[200];

int y_tab[200];

// ********

void initpoint( int point, float x, float y, float z);
void initface ( int face, int a, int b, int c, int d);

void initall();

void rotate();
void project();

void polydraw();
void Poly( int Face );
void polyfix( int x1, int y1, int x2, int y2, byte col1, byte col2);

byte buffer[64000];

// **********

int main()
{
   SetMCGA();

   initall();

   do
   {
      rotate();
      project();
      polydraw();
      WaitRetrace();

      memcpy( vga, buffer, 64000);
      memset( buffer, 0, 64000);

   } while ( !kbhit() );

   SetText();

   return 0;
}


// ************ DRAW ******************************************

void polyfix( int x1, int y1, int x2, int y2, byte col1, byte col2)
{
   if( y2 < y1 )
   {
      int temp = y1;
      y1 = y2;
      y2 = temp;

      temp = x1;
      x1 = x2;
      x2 = temp;

      byte tmp = col1;
      col1 = col2;
      col2 = tmp;
   }

   if( y2 == y1 )
   {
      startx[y1] = x1;
      endx  [y1] = x2;
   }
   else
   {
      int X, Y, Step, col, colstep;

      X = x1 << 16;
      Step = ((x2-x1) << 16) / (y2-y1);

      col = col1 << 16;
      colstep = ((col2-col1) << 16) / (y2-y1);

      X += Step;
      y1++;

      for( Y = y1; Y <= y2; Y++)
      {
         if(( Y>=0 )&&( Y<200 ))
         {
            if( startx[ Y ] == -1)
            {
               startx[ Y ] = (X >> 16);
               startcol[ Y ] = (col >> 16); 
            }
            else
            {
               if( (X >> 16) < 320 )
               {
                  endx[ Y ] = (X >> 16);
                  endcol[ Y ] = (col >> 16 );
               }      
               else
               {
                  endx[ Y ] = 319;
                  endcol[ Y ] = (col >> 16 );
               }
            }
         }

         X += Step;
         col += colstep;
      }
   }
}

void polydraw()
{
   for( int i=0; i<6; i++ )
   {
      int p0 = kubf[i][0];
      int p1 = kubf[i][1];
      int p2 = kubf[i][2];
      int p3 = kubf[i][3];

      float norm =   ((rotp[p3].y - rotp[p0].y) * (rotp[p1].x - rotp[p0].x))
                   - ((rotp[p1].y - rotp[p0].y) * (rotp[p3].x - rotp[p0].x));

      if( norm < -0.2 )
         Poly( i );

   }
}

void Poly( int Face )
{
   for( int i=0; i<200; i++)
   {
      startx[i] |= ~startx[i];
      endx[i]   |= ~endx[i];
   }

   for( i=0; i<3; i++)
   {
      polyfix( rotp[ kubf[Face][i  ] ].px,
               rotp[ kubf[Face][i  ] ].py,
               rotp[ kubf[Face][i+1] ].px,
               rotp[ kubf[Face][i+1] ].py,
               kubp[ kubf[Face][i  ] ].col,
               kubp[ kubf[Face][i+1] ].col );
   }

   polyfix( rotp[ kubf[Face][3] ].px,
            rotp[ kubf[Face][3] ].py,
            rotp[ kubf[Face][0] ].px,
            rotp[ kubf[Face][0] ].py,
            kubp[ kubf[Face][3] ].col,
            kubp[ kubf[Face][0] ].col );

   for( i=0; i<200; i++ )
   {
      if( startx[i] != -1 )
      {         
         if( endx[i] == -1)
             buffer[ y_tab[i]+startx[i] ] = startcol[i];
         else
         {
            if( startx[i] > endx[i] )
            {
               int temp = startx[i];
               startx[i] = endx[i];
               endx[i] = temp;
         
               byte tmp = startcol[i];
               startcol[i] = endcol[i];
               endcol[i] = tmp;
            }

            int colorstep = ((endcol[i]-startcol[i] + 1) << 16) / (endx[i]-startx[i]+1);
            int color = startcol[i] << 16;

            if( Face==0 || Face == 2 )
               for( int x=startx[i]; x<=endx[i]; x++)
               {
                  buffer[ y_tab[i]+x ] = (byte) (color >> 16);
                  color += colorstep;
               }
            else if( Face==1 || Face == 3 ) 
               for( int x=startx[i]; x<=endx[i]; x++)
               {
                  buffer[ y_tab[i]+x ] = 64 + (byte) (color >> 16);
                  color += colorstep;
               }
            else
               for( int x=startx[i]; x<=endx[i]; x++)
               {
                  buffer[ y_tab[i]+x ] = 128 + (byte) (color >> 16);
                  color += colorstep;
               }

         }
      }
   }
}




// ************ PROJECT ***************************************

void rotate()
{
   static double Xangle = 0;
   static double Yangle = 0;
   static double Zangle = 0;

   Xangle += 0.03;
   Yangle += 0.02;
   Zangle += 0.04;
	
   float sinX = sin(Xangle);
   float cosX = cos(Xangle);

   float sinY = sin(Yangle);
   float cosY = cos(Yangle);

   float sinZ = sin(Zangle);
   float cosZ = cos(Zangle);

   float temp;

   for( int i=0; i<8; i++)       
	{
      rotp[i].y = kubp[i].y * cosZ - kubp[i].x * sinZ;
      rotp[i].x = kubp[i].x * cosZ + kubp[i].y * sinZ;

      rotp[i].z = kubp[i].z * cosY - rotp[i].x * sinY;
      rotp[i].x = rotp[i].x * cosY + kubp[i].z * sinY;

      temp      = rotp[i].y * cosX + rotp[i].z * sinX;
      rotp[i].z = rotp[i].z * cosX - rotp[i].y * sinX;
      rotp[i].y = temp;

      kubp[i].col = (byte) (((rotp[i].z)+1.8) * 16);
	}
}

void project()
{
   for( int i=0; i<8; i++ )
   {
      rotp[i].px = (( rotp[i].x / (rotp[i].z + 15)) * 700) + 160;      
      rotp[i].py = (( rotp[i].y / (rotp[i].z + 15)) * 600) + 100;      
   }
}

// ************* INITS *****************************************

void initall()
{
   for( int i=0; i<64; i++)
   {
      Pal( i,0,0,i );
   }

   for( i=64; i<128; i++)
   {
      Pal( i,i-64,0,0 );
   }

   for( i=128; i<192; i++)
   {
      Pal( i,0,i-128,0 );
   }

   for( i=192; i<255; i++)
   {
      Pal( i,63,63,63);
   }

   for( i=0; i<200; i++ )
   {
      y_tab[i] = i*320;
   }

   initpoint( 0,  1,  1, 1 );
   initpoint( 1,  1, -1, 1 );
   initpoint( 2, -1, -1, 1 );
   initpoint( 3, -1,  1, 1 );

   initpoint( 4,  1,  1, -1 );
   initpoint( 5,  1, -1, -1 );
   initpoint( 6, -1, -1, -1 );
   initpoint( 7, -1,  1, -1 );

   initface( 0, 0,3,2,1);
   initface( 1, 4,0,1,5);
   initface( 2, 7,4,5,6);
   initface( 3, 3,7,6,2);
   initface( 4, 7,3,0,4);
   initface( 5, 5,1,2,6);

   kubp[0].col = 0;
   kubp[1].col = 15;
   kubp[2].col = 63;
   kubp[3].col = 32;
   kubp[4].col = 63;
   kubp[5].col = 32;
   kubp[6].col = 0;
   kubp[7].col = 15;
}

void initpoint( int point, float x, float y, float z)
{
   kubp[point].x = x;
   kubp[point].y = y;
   kubp[point].z = z;
}

void initface ( int face, int a, int b, int c, int d)
{
   kubf[face][0] = a;
   kubf[face][1] = b;
   kubf[face][2] = c;
   kubf[face][3] = d;
}
   
